/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package tiledownloader;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author Jorgen
 */
public class TileDownloaderView extends javax.swing.JFrame implements FinishedListener
{
    private static final int                MAXTHREADS=3;
    private static final int                MAXSTATUSSTRINGS=3;
    
    private boolean                         started;
    private DownloadThread[]                threads;
    private int                             xmin;
    private int                             xmax;
    private int                             ymin;
    private int                             ymax;
    private int                             zoomLevel;
    private int                             x;
    private int                             y;
    private boolean                         error;
    private ArrayList<DownloadRequest>[]    retryQueue;
    
    private String                          statusStrings[];
    
    /**
     * Creates new form TileDownloaderView
     */
    public TileDownloaderView()
    {
        int i;
        
        initComponents();
        
        // Set the threads started flag to false. Nothing has been started...
        started =false;
        error   =false;
        
        
        statusStrings=new String[MAXSTATUSSTRINGS];
        i=0;
        while(i<MAXSTATUSSTRINGS)
        {
            statusStrings[i]="";
            i++;
        }

        calculateParameters();
        this.printStatus(2, "Ready!");
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jPanel1 = new javax.swing.JPanel();
        jTextFieldLat1 = new javax.swing.JTextField();
        jTextFieldLat2 = new javax.swing.JTextField();
        jTextFieldLon1 = new javax.swing.JTextField();
        jTextFieldLon2 = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldDirectory = new javax.swing.JTextField();
        jTextFieldServer1 = new javax.swing.JTextField();
        jTextFieldServer2 = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextAreaStatus = new javax.swing.JTextArea();
        jButtonDownload = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();
        jTextFieldServer3 = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jTextFieldZoomLevel = new javax.swing.JTextField();
        jTextFieldXmax = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jTextFieldYmin = new javax.swing.JTextField();
        jTextFieldYmax = new javax.swing.JTextField();
        jTextFieldXmin = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jTextFieldDefaultImage = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jTextDelay = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jTextFieldLat1.setText("29.33");
        jTextFieldLat1.addKeyListener(new java.awt.event.KeyAdapter()
        {
            public void keyReleased(java.awt.event.KeyEvent evt)
            {
                jTextFieldLat1KeyReleased(evt);
            }
        });

        jTextFieldLat2.setText("28.83");
        jTextFieldLat2.addKeyListener(new java.awt.event.KeyAdapter()
        {
            public void keyReleased(java.awt.event.KeyEvent evt)
            {
                jTextFieldLat2KeyReleased(evt);
            }
        });

        jTextFieldLon1.setText("-13.9");
        jTextFieldLon1.addKeyListener(new java.awt.event.KeyAdapter()
        {
            public void keyReleased(java.awt.event.KeyEvent evt)
            {
                jTextFieldLon1KeyReleased(evt);
            }
        });

        jTextFieldLon2.setText("-13.4");
        jTextFieldLon2.addKeyListener(new java.awt.event.KeyAdapter()
        {
            public void keyReleased(java.awt.event.KeyEvent evt)
            {
                jTextFieldLon2KeyReleased(evt);
            }
        });

        jLabel5.setText("lat 1");

        jLabel6.setText("lat 2");

        jLabel7.setText("lon 1");

        jLabel8.setText("lon 2");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(23, 23, 23)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLat1, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(24, 24, 24)
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLat2, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(62, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextFieldLon1, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel8)
                    .addComponent(jTextFieldLon2, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldLat1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(jLabel8))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldLon1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldLon2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldLat2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6)))
        );

        jLabel1.setText("Output Directory");

        jLabel2.setText("Server 1");

        jLabel3.setText("Server 2");

        jLabel4.setText("Server 3");

        jTextFieldDirectory.setText("d:\\test");
        jTextFieldDirectory.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jTextFieldDirectoryActionPerformed(evt);
            }
        });

        jTextFieldServer1.setText("https://a.tile.opentopomap.org/$z/$x/$y.png");

        jTextFieldServer2.setText("https://b.tile.opentopomap.org/$z/$x/$y.png");

        jTextAreaStatus.setColumns(20);
        jTextAreaStatus.setRows(4);
        jScrollPane1.setViewportView(jTextAreaStatus);

        jButtonDownload.setText("Download");
        jButtonDownload.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButtonDownloadActionPerformed(evt);
            }
        });

        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButtonCancelActionPerformed(evt);
            }
        });

        jTextFieldServer3.setText("https://c.tile.opentopomap.org");

        jLabel9.setText("Zoom level");

        jTextFieldZoomLevel.setText("10");
        jTextFieldZoomLevel.addKeyListener(new java.awt.event.KeyAdapter()
        {
            public void keyReleased(java.awt.event.KeyEvent evt)
            {
                jTextFieldZoomLevelKeyReleased(evt);
            }
        });

        jTextFieldXmax.setEditable(false);
        jTextFieldXmax.setText("0");

        jLabel10.setText("xmin");

        jLabel11.setText("xmax");

        jLabel12.setText("ymin");

        jLabel13.setText("ymax");

        jTextFieldYmin.setEditable(false);
        jTextFieldYmin.setText("0");

        jTextFieldYmax.setEditable(false);
        jTextFieldYmax.setText("0");

        jTextFieldXmin.setEditable(false);
        jTextFieldXmin.setText("0");

        jLabel14.setText("Default image");

        jTextFieldDefaultImage.setText("d:\\test\\default.png");

        jLabel15.setText("Delay betwen requests");

        jTextDelay.setText("100");

        jLabel16.setText("ms (100-60000 ms)");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(44, 44, 44)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel11)
                                    .addComponent(jLabel12)
                                    .addComponent(jLabel10)
                                    .addComponent(jLabel13))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jTextFieldYmax, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jTextFieldXmax, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jTextFieldXmin, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jTextFieldYmin, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jLabel9)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jTextFieldZoomLevel, javax.swing.GroupLayout.PREFERRED_SIZE, 125, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 566, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel1)
                                    .addComponent(jLabel2)
                                    .addComponent(jLabel14)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addComponent(jLabel4)
                                        .addComponent(jLabel3))
                                    .addComponent(jLabel15))
                                .addGap(38, 38, 38)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jTextFieldServer3)
                                    .addComponent(jTextFieldServer2, javax.swing.GroupLayout.DEFAULT_SIZE, 417, Short.MAX_VALUE)
                                    .addComponent(jTextFieldServer1)
                                    .addComponent(jTextFieldDirectory)
                                    .addComponent(jTextFieldDefaultImage)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jTextDelay, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jLabel16))))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(155, 155, 155)
                        .addComponent(jButtonDownload)
                        .addGap(141, 141, 141)
                        .addComponent(jButtonCancel)))
                .addGap(0, 35, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel10)
                            .addComponent(jTextFieldXmin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldXmax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel11))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel12)
                            .addComponent(jTextFieldYmin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel9)
                            .addComponent(jTextFieldZoomLevel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel13)
                            .addComponent(jTextFieldYmax, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldDirectory, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextFieldServer1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jTextFieldServer2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jTextFieldServer3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(24, 24, 24)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(jTextFieldDefaultImage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel15)
                    .addComponent(jTextDelay, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel16))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 103, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonDownload)
                    .addComponent(jButtonCancel))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTextFieldDirectoryActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jTextFieldDirectoryActionPerformed
    {//GEN-HEADEREND:event_jTextFieldDirectoryActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldDirectoryActionPerformed

    private void jButtonDownloadActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButtonDownloadActionPerformed
    {//GEN-HEADEREND:event_jButtonDownloadActionPerformed
        // If no process is running, start the download process
        if (!started)
        {
            started=true;
            // Start up the threads. They start idling
            startThreads();
            
            // Calculate the tile parameters
            calculateParameters();
            
            // Trigger the threads to download
            startDownloading();
            this.printStatus(2, "Started!");
        }
        else
        {
            this.printStatus(2, "Already running!");
        }
    }//GEN-LAST:event_jButtonDownloadActionPerformed

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButtonCancelActionPerformed
    {//GEN-HEADEREND:event_jButtonCancelActionPerformed
        int             i;
        DownloadThread  localThread;
        boolean         localStarted;
        
        // Check if the thread has been started
        synchronized(this)
        {
            localStarted=started;
        }
        
        if (localStarted)
        {
            this.printStatus(2, "Canceling, please wait...");

            i=0;
            while (i<MAXTHREADS)
            {
                // Get a thread
                synchronized(this)
                {
                    // Copy to local
                    localThread =threads[i];
                    // Set the original to null. We've still got a local reference
                    threads[i]  =null;
                }                
                
                // If the local reference != null, stop it and wait till it stopped.
                if (localThread!=null)
                {
                    localThread.stop();
                }
                i++;
            }

            synchronized(this)
            {
                started=false;
            }
            this.printStatus(2, "Canceled");
        }
        else
        {
            this.printStatus(2, "No process active");
        }

    }//GEN-LAST:event_jButtonCancelActionPerformed

    /**
     * Zoom text filed key released handler. Update the parameters on the screen
     * @param evt Key event
     */
    private void jTextFieldZoomLevelKeyReleased(java.awt.event.KeyEvent evt)//GEN-FIRST:event_jTextFieldZoomLevelKeyReleased
    {//GEN-HEADEREND:event_jTextFieldZoomLevelKeyReleased
        this.calculateParameters();
    }//GEN-LAST:event_jTextFieldZoomLevelKeyReleased

    /**
     * Lat 1 text filed key released handler. Update the parameters on the screen
     * @param evt Key event
     */
    private void jTextFieldLat1KeyReleased(java.awt.event.KeyEvent evt)//GEN-FIRST:event_jTextFieldLat1KeyReleased
    {//GEN-HEADEREND:event_jTextFieldLat1KeyReleased
        this.calculateParameters();
    }//GEN-LAST:event_jTextFieldLat1KeyReleased

    /**
     * Lat 2 text filed key released handler. Update the parameters on the screen
     * @param evt Key event
     */
    private void jTextFieldLat2KeyReleased(java.awt.event.KeyEvent evt)//GEN-FIRST:event_jTextFieldLat2KeyReleased
    {//GEN-HEADEREND:event_jTextFieldLat2KeyReleased
        this.calculateParameters();
    }//GEN-LAST:event_jTextFieldLat2KeyReleased

    /**
     * Lon 1 text filed key released handler. Update the parameters on the screen
     * @param evt Key event
     */
    private void jTextFieldLon1KeyReleased(java.awt.event.KeyEvent evt)//GEN-FIRST:event_jTextFieldLon1KeyReleased
    {//GEN-HEADEREND:event_jTextFieldLon1KeyReleased
        this.calculateParameters();
    }//GEN-LAST:event_jTextFieldLon1KeyReleased

    /**
     * Lon 2 text filed key released handler. Update the parameters on the screen
     * @param evt Key event
     */
    private void jTextFieldLon2KeyReleased(java.awt.event.KeyEvent evt)//GEN-FIRST:event_jTextFieldLon2KeyReleased
    {//GEN-HEADEREND:event_jTextFieldLon2KeyReleased
        this.calculateParameters();
    }//GEN-LAST:event_jTextFieldLon2KeyReleased

    /**
     * Add the status and print it
     * @param line Line number 
     * @param status Text
     */
    private void printStatus(int line, String status)
    {
        String  text;
        int     i;
        
        if ((line>=0) && (line<MAXSTATUSSTRINGS))
        {
            synchronized (this)
            {
                statusStrings[line]=status;
                i=0;
                text="";
                while(i<MAXSTATUSSTRINGS)
                {
                    text+=statusStrings[i]+"\n";
                    i++;
                }
            }
            this.jTextAreaStatus.setText(text);
        }
        
    }
    
    /**
     * Kicks the download threads into life. The threads 
     * start idling, waiting for a job
     */
    private void startThreads()
    {
        
        String              server;
        String              directory;
        String              defaultImage;
        int                 zoomLevel;
        int                 delay;
        
        
        threads     =new DownloadThread[MAXTHREADS];
        retryQueue  =new ArrayList[MAXTHREADS];
        
        // Get the zoomlevel
        zoomLevel   =Integer.parseInt(jTextFieldZoomLevel.getText());
        
        // Get the directory
        directory   =jTextFieldDirectory.getText();
        
        defaultImage=this.jTextFieldDefaultImage.getText();

        try
        {
            delay       =Integer.parseInt(this.jTextDelay.getText());
        }
        catch (NumberFormatException e)
        {
            
            this.printStatus(1, "Illegal delay: "+this.jTextDelay.getText()+". Setting it to 100 ms");
            delay=100;
        }
            
                
        
        delay       =Math.max(100, delay);
        delay       =Math.min(60000, delay);
        
        this.jTextDelay.setText(Integer.toString(delay));
        
        // Create a thread for each server
        // To do: create multiple threads per server??
        server=jTextFieldServer1.getText();
        if (!server.equals(""))
        {
            DebugLogger.info("Starting thread 0");
            threads[0]      =new DownloadThread(server, 0, directory, defaultImage, zoomLevel, delay, this);
            retryQueue[0]   =new ArrayList();
        }
        else
        {
            threads[0]=null;
        }

        server=jTextFieldServer2.getText();
        if (!server.equals(""))
        {
            DebugLogger.info("Starting thread 1");
            threads[1]      =new DownloadThread(server, 1, directory, defaultImage, zoomLevel, delay, this);
            retryQueue[1]   =new ArrayList();
        }
        else
        {
            threads[1]=null;
        }
        
        server=jTextFieldServer3.getText();
        if (!server.equals(""))
        {
            DebugLogger.info("Starting thread 2");
            threads[2]      =new DownloadThread(server, 2, directory, defaultImage, zoomLevel, delay, this);
            retryQueue[2]   =new ArrayList();
        }
        else
        {
            threads[2]=null;
        }
        
        
        
    }
    
   
    /**
     * The arcsinh function
     * @param x Angle in radians
     * @return asinh value
     */
    private double asinh(double x)
    {
        return Math.log(x + Math.sqrt(x*x + 1.0));
    }
    
    /**
     * Calaculate the parameters xmin, xmax, ymin, ymax and zoomlevel.
     * Update the text boxes on the screen
     */
    private void calculateParameters()
    {
        
        double      zoom=0;
        
        double      lat1=0;
        double      lat2=0;
        double      lon1=0;
        double      lon2=0;
        double      lat;
        
        
        error=false;
        try
        {
            lat1=Double.parseDouble(jTextFieldLat1.getText());
            lat2=Double.parseDouble(jTextFieldLat2.getText());
            lon1=Double.parseDouble(jTextFieldLon1.getText());
            lon2=Double.parseDouble(jTextFieldLon2.getText());
                 
            zoom=Double.parseDouble(jTextFieldZoomLevel.getText());
            zoomLevel=Integer.parseInt(jTextFieldZoomLevel.getText());
        }
        catch (Exception e)
        {
            error=true;
            this.printStatus(1, "Error in lat or lon");
        }
        
        if (!error)
        {
            xmin=(int)(Math.min(lon1, lon2)*Math.pow(2, zoom)/360.0+Math.pow(2.0, zoom)/2.0);
            xmax=(int)(Math.max(lon1, lon2)*Math.pow(2, zoom)/360.0+Math.pow(2.0, zoom)/2.0)+1;

            this.jTextFieldXmin.setText(Integer.toString(xmin));
            this.jTextFieldXmax.setText(Integer.toString(xmax));

            lat=asinh(Math.tan(Math.min(lat1, lat2)/360.0*2.0*Math.PI));
            ymax=(int)(Math.pow(2.0, zoom)/2.0-lat*Math.pow(2.0, zoom)/(2.0*Math.PI))+1;
            lat=asinh(Math.tan(Math.max(lat1, lat2)/360.0*2.0*Math.PI));
            ymin=(int)(Math.pow(2.0, zoom)/2.0-lat*Math.pow(2.0, zoom)/(2.0*Math.PI));

            this.jTextFieldYmin.setText(Integer.toString(ymin));
            this.jTextFieldYmax.setText(Integer.toString(ymax));        
            this.printStatus(1, "Parameters calculated");

            
        }
        
    }
    
    /**
     * Trigger the threads to to download the next tile
     */
    private void startDownloading()
    {
        int i;
        
        if (!error)
        {
            synchronized(this)
            {
                x=xmin;
                y=ymin;
            }

            // Signal the threads to download the next tile
            i=0;
            while (i<MAXTHREADS)
            {
                if (threads[i]!=null)
                {
                    this.notifyFinished(threads[i].getId());
                }
                i++;
            }
        }
        else
        {
            // Stop the threads
            i=0;
            while (i<MAXTHREADS)
            {
                DebugLogger.info("Error: Stopping thread "+i);
                threads[i].stop();
                i++;
            }
        }
    }
    
    /**
     * The finished listener
     */
    @Override
    public void notifyFinished(int id)
    {
        int                         i;
        int                         j;
        int                         localX;
        int                         localY;
        boolean                     allStopped;
        DownloadThread              localThread;
        boolean                     nextStop;
        DownloadRequest             nextRequest;
        Iterator<DownloadRequest>   it;
        double                      progress;
        
        localX          =0;
        localY          =0;
        localThread     =null;
        nextRequest     =null;
        nextStop        =false;
        progress        =0.0;

        // Synchronize next section, since it is called from 
        // multiple threads. This section updates the administration
        synchronized(this)
        {
            i=0;
            while (i<MAXTHREADS)
            {
                // Find the thread based on the id passed
                if (threads[i]!=null && threads[i].getId()==id)
                {
                    // The thread to use 
                    localThread =threads[i];

                    // If requests are pending in the retry queue, these prevail
                    if (!retryQueue[i].isEmpty())
                    {
                        // Get the next request from the queue
                        it=retryQueue[i].iterator();    // Get the iterator
                        nextRequest=it.next();          // Get next request
                        it.remove();                    // Remove the request from the queue
                    }
                    else
                    {
                        // Get the coordinates of the next tile to download
                        localX      =x;
                        localY      =y;                            
                        
                        // Check if it is the first tile outside the area
                        // That is the signal to stop downloading
                        if (localX>xmax)
                        {
                            // No more to download: stop the thread.
                            nextStop    =true; 
                            // Set the reverence to null; we still got the reference
                            // in localThread.
                            threads[i]  =null;
                        }
                        else
                        {
                            // Create progress (0.0-1.0). We download ymin<=y<=ymax and xmin<=x<=xmax.
                            // So the number of tiles is: (ymax-ymin+1)*(xmax-xmin+1)
                            progress=(double)(((x-xmin)*(ymax-ymin+1)+(y-ymin+1))/(double)((ymax-ymin+1)*(xmax-xmin+1)));
                            
                            // Valid x and y: create next request to download
                            nextRequest=new DownloadRequest(id, x, y);

                            // Increase y and x for the next thread
                            y++;
                            if (y>ymax)
                            {
                                y=ymin;
                                x++;
                            }

                        }
                    }

                }
                i++;
            }
        }

        
        if (nextStop)
        {
            // If so, stop this thread
            DebugLogger.info("No more to download: Stopping "+localThread.getId());
            localThread.signalStop();

            synchronized (this)
            {
                // Check if all threads have stopped now
                j=0;
                allStopped=true;
                while (j<MAXTHREADS && allStopped)
                {
                    if (threads[j]!=null)
                    {
                        allStopped=false;
                    }
                    j++;
                }
            }

            // If so, we are ready!!
            if (allStopped)
            {
                // Notify the user
                this.printStatus(2, "Ready!");
                
                // Set started to false: ready for next session
                this.started=false;
            }            
        }
        
        // If a new request exists, download the requested tile
        if (nextRequest!=null)
        {
            // Download this tile
            this.printStatus(0, "Downloading "+nextRequest.x+", "+nextRequest.y+" @ thread "+localThread.getId()+" Progress: "+String.format("%2.2f", progress*100.0)+"%");
            localThread.doDownloadTile(nextRequest);
        }
        
        
        
    }
    
    /**
     * Notify that the donwload failed even after retries. 
     * Try it on another server.  Since the notifyFinished() is not called
     * the failing thread is not triggered again.
     * @param id Thread ID of the failing thread
     * @param request Request that failed
     */
    @Override
    public void notifyFailed(int id, DownloadRequest failingRequest)
    {
        int                             i;
        DownloadThread                  failingThread;
        DownloadThread                  newThread;
        ArrayList<DownloadRequest>      queue;
        String                          status;
        int                             newId;
        
        failingThread   =null;
        queue           =null;
        newThread       =null;
        newId           =-1;
        
        synchronized(this)
        {
            // Find the failing thread
            i=0;
            while (i<MAXTHREADS)
            {
                if (threads[i]!=null && this.threads[i].getId()==id)
                {
                    failingThread=this.threads[i];
                    this.threads[i]=null;
                }
                i++;
            }

            // Find the retry queue beloning to another thread
            i=0;
            while (i<MAXTHREADS)
            {
                if (threads[i]!=null && this.threads[i].getId()!=id)
                {
                    newThread   =this.threads[i];
                    queue       =this.retryQueue[i];
                    newId       =i;
                }
                i++;
            }
        }
        
        // There is a slight chance that the failed thread has been stopped
        if (failingThread!=null)
        {
            if (queue!=null)
            {
                // Print some error message and add the request to the retry queue of the other thread
                status="Error downloading from server "+id+". Trying server "+newId+". x="+failingRequest.x+" y="+failingRequest.y;
                DebugLogger.error(status);
                this.printStatus(1, status);
                queue.add(failingRequest);
            }
            else
            {
                status="Error downloading from server "+id+". No more servers to relay to. Just press cancel :-(";
                DebugLogger.error(status);
                this.printStatus(1, status);
            }
            // Signal the failing thread to stop
            failingThread.signalStop();
        }
        else
        {
            status="Error downloading file. Thread has been stopped though";
            DebugLogger.error(status);
            this.printStatus(1, status);
        }
    }
    
   
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonDownload;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextAreaStatus;
    private javax.swing.JTextField jTextDelay;
    private javax.swing.JTextField jTextFieldDefaultImage;
    private javax.swing.JTextField jTextFieldDirectory;
    private javax.swing.JTextField jTextFieldLat1;
    private javax.swing.JTextField jTextFieldLat2;
    private javax.swing.JTextField jTextFieldLon1;
    private javax.swing.JTextField jTextFieldLon2;
    private javax.swing.JTextField jTextFieldServer1;
    private javax.swing.JTextField jTextFieldServer2;
    private javax.swing.JTextField jTextFieldServer3;
    private javax.swing.JTextField jTextFieldXmax;
    private javax.swing.JTextField jTextFieldXmin;
    private javax.swing.JTextField jTextFieldYmax;
    private javax.swing.JTextField jTextFieldYmin;
    private javax.swing.JTextField jTextFieldZoomLevel;
    // End of variables declaration//GEN-END:variables
}
